<div *ngIf="userLevelThreads.length > 1" class="container" style="clear: both; margin-top: 64px">
  <!-- Additional Settings -->
  <h1>{{ 'scheduling.diagram.headline' | translate }}</h1>

  <div class="button-container">
    <button class="btn btn-primary" (click)="checkExcercise()">
      <fa-icon [icon]="faCheck"></fa-icon>
      {{ 'scheduling.diagram.check' | translate }}
    </button>
    <button class="btn btn-secondary" (click)="resetDiagram()">
      <fa-icon [icon]="faRecycle"></fa-icon>
      {{ 'scheduling.diagram.reset' | translate }}
    </button>
    <button class="btn btn-secondary" (click)="printConfig()">
      <fa-icon [icon]="faShare"></fa-icon>
      {{ 'scheduling.diagram.share' | translate }}
    </button>
    <button class="btn btn-secondary" (click)="exportDiagram()">
      <fa-icon [icon]="faShare"></fa-icon>
      {{ 'scheduling.diagram.export' | translate }}
    </button>
    <button class="btn btn-secondary" (click)="toggleHelp()">
      <fa-icon [icon]="faQuestion"></fa-icon>
      {{ 'scheduling.diagram.help' | translate }}
    </button>
  </div>

  <div *ngIf="showHelp" class="alert alert-dismissible alert-secondary textwithnewline">
    <button type="button" class="btn-close" (click)="toggleHelp()"></button>
    <h4 class="alert-heading">{{ 'scheduling.diagram.helpHeading' | translate }}</h4>
    {{ 'scheduling.diagram.helpBody' | translate }}
  </div>

  <div
    *ngIf="debugActivated"
    class="alert alert-dismissible alert-secondary textwithnewline"
    style="word-break: break-all"
  >
    <button type="button" class="btn-close" (click)="toggleDebugActivated()"></button>
    <h4 class="alert-heading">Debug</h4>
    <button type="button" class="btn btn-warning" (click)="printJSONUserlevelThreads()">
      TestConfiguration erstellen
    </button>
    <button type="button" class="btn btn-warning left-margin" (click)="toggleCorrectionVisible()">
      Lösung anzeigen
    </button>
    <button type="button" class="btn btn-warning left-margin" (click)="printJSON()">Diagram JSONString Drucken</button>
    <button type="button" class="btn btn-warning left-margin" (click)="printCustomTransport()">
      Custom Transport Drucken
    </button>

    <h3 *ngIf="diagramJSON != ''">Userlevelthreads</h3>
    <p>
      {{ diagramJSON }}
    </p>
    <h3 *ngIf="diagramJSONKernelthreads != ''">Kernellevelthreads</h3>
    <p>
      {{ diagramJSONKernelthreads }}
    </p>
  </div>

  <!-- Diagram -->

  <dts-select-container
    [(selectedItems)]="selectedCells"
    (select)="dragSelected($event)"
    #selectContainer="dts-select-container"
    [selectMode]="selectMode"
    [disabled]="disable"
    [disableRangeSelection]="disableRangeSelection"
    [selectOnDrag]="selectOnDrag"
    [selectWithShortcut]="selectWithShortcut"
    class="scrollable"
  >
    <table>
      <tr>
        <td class="rowLabel"></td>
        <td *ngFor="let number of userLevelThreads[0].cells; index as y" class="firstRow">{{ y }}</td>
      </tr>
      <tr class="tableBody" *ngFor="let userThread of userLevelThreads">
        <td class="rowLabel" style="">
          {{ userThread.name }}
        </td>

        <td
          *ngFor="let cell of userThread.cells; index as x"
          [dtsSelectItem]="cell"
          (click)="cellClickedIndividual(cell, userThread)"
          [ngStyle]="cellStyle(cell)"
        >
          <span class="correctionIndex">{{ cell.correctionIndex }}</span>
          {{ cell.status }}
          <span *ngIf="correctionVisible"><br />{{ cell.corrected }}</span>
        </td>
      </tr>
    </table>
  </dts-select-container>

  <div class="form-check form-switch flex-container">
    <div>
      <input
        class="form-check-input"
        id="preemptiveSpecificationKernel"
        name="prioritySpecificationKernel"
        type="checkbox"
        [(ngModel)]="diagram.showHelpGuides"
      />
      <label class="form-check-label" style="margin-left: 8px" for="preemptiveSpecificationKernel">{{
        'scheduling.diagram.helplines' | translate
      }}</label>
    </div>
    <div *ngIf="diagram.showHelpGuides" class="flexible-margin item-large">
      {{ 'scheduling.diagram.legend.label' | translate }}:
    </div>

    <div *ngIf="diagram.showHelpGuides" class="item">
      <div class="color-block" style="background: var(--blue-correction)"></div>
    </div>
    <div *ngIf="diagram.showHelpGuides" class="item">{{ 'scheduling.diagram.legend.arrivaltime' | translate }}</div>

    <div *ngIf="diagram.showHelpGuides" class="item">
      <div class="color-block" style="background: var(--orange-correction)"></div>
    </div>
    <div *ngIf="diagram.showHelpGuides" class="item">{{ 'scheduling.diagram.legend.deadline' | translate }}</div>
  </div>

  <div
    *ngIf="diagram.correctionText != '' && diagram.atLeastOnceCorrected"
    class="alert alert-dismissible alert-secondary textwithnewline"
    style="margin-top: 16px"
  >
    <button type="button" class="btn-close" (click)="toggleCorrectionTextActivated()"></button>
    <h4 class="alert-heading">{{ 'scheduling.diagram.correctionnote' | translate }}</h4>
    {{ diagram.correctionText }}
  </div>

  <div
    *ngIf="configurationString !== ''"
    title="{{ 'scheduling.diagram.configurationhint' | translate }}"
    class="alert alert-dismissible alert-secondary textwithnewline"
    style="margin-top: 32px; word-break: break-all"
  >
    <span style="float: right">
      <span *ngIf="showCopied" style="margin-right: 16px" class="badge rounded-pill bg-primary">{{
        'scheduling.diagram.copyPopUp' | translate
      }}</span>
      <fa-icon
        [icon]="faCopy"
        [cdkCopyToClipboard]="configurationString"
        (click)="showCopyPopup()"
        title="{{ 'scheduling.diagram.copy' | translate }}"
      ></fa-icon>
      <button type="button" class="btn-close" (click)="toggleConfigurationActivated()"></button>
    </span>

    <h4 class="alert-heading">{{ 'scheduling.diagram.configuration' | translate }}</h4>
    {{ configurationString }}
  </div>
</div>
